/*
 *  802dot11smt mib
 *
 *
 *

 #include <time.h>

 bool ===> u_int8_t

 MAC  ===> char [LENGTH_OF_MACADDRESS]

 WEPKeytype  ===> char [LENGTH_OF_WEPKEYTYPE]

 RowStatus  ===>  char [LENGTH_OF_ROWSTATUS]
 
 Counter32  ===>  u_int32_t
 
*/

#ifndef _MIBGROUP_HiMIPv6_H
#define _MIBGROUP_HiMIPv6_H

#define	LENGTH_OF_MACADDRESS	12
#define	LENGTH_OF_WEPKEYTYPE	20
#define	LENGTH_OF_ROWSTATUS	20

    /*
     * Declare our publically-visible functions.
     * Typically, these will include the initialization and shutdown functions,
     *  the main request callback routine and any writeable object methods.
     *
     * Function prototypes are provided for the callback routine ('FindVarMethod')
     *  and writeable object methods ('WriteMethod').
     */
     
	extern	void		init_802dot11smt(void);
	extern 	FindVarMethod 	var_HiMIPv6_Statistics_entry;
	extern 	FindVarMethod 	var_HiMIPv6_VisitorList_entry;
	
	
	
/*

/* config file parsing routines 
extern void qos_free_config (void);
extern void qos_parse_config (char *, char *);

/* add the QOS-ROUTER to the list of default mibs to parse
config_add_mib(QOS-MIB)


*/



    /*
     * We use 'header_generic' from the util_funcs module,
     *  so make sure this module is included in the agent.
     
config_require(util_funcs)

*/



    /*
     * Magic number definitions.
     * These must be unique for each object implemented within a
     *  single mib module callback routine.
     *
     * Typically, these will be the last OID sub-component for
     *  each entry, or integers incrementing from 1.
     *  (which may well result in the same values anyway).
     *
     * Here, the second and third objects are form a 'sub-table' and
     *   the magic numbers are chosen to match these OID sub-components.
     * This is purely for programmer convenience.
     * All that really matters is that the numbers are unique.
     */

// HiMIPv6

// dot11StationConfigTable  { HiMIPv6 1 }

// StatisticsTableEntry   { StatisticsTable 1 }


#define	MIPv6_BU_rcvd			1
#define	MIPv6_BA_rcvd			2
#define	MIPv6_BR_rcvd			3
#define	MIPv6_BU_sent			4
#define	MIPv6_BA_sent			5
#define	MIPv6_BR_sent			6
#define	MIPv6_RA_rcvd			7
#define	HiMIPv6_HiRA_rcvd			8
#define	HiMIPv6_HiBU_rcvd			9
#define	HiMIPv6_HiBI_rcvd			10
#define	HiMIPv6_HiBU_sent			11
#define	HiMIPv6_HiBI_sent			12
#define	HiMIPv6_HiBA_rcvd			13
#define	HiMIPv6_HiBA_sent			14
#define	HiMIPv6_HiBA_passed		15
#define   HiMIPv6_HiBU_passed		16
#define   HiMIPv6_HiBU_blocked		17




// VisitorListTable  {  HiMIPv6 2 }

// VisitorListTableEntry { VisitorListTable 1 }

#define   HiMIPv6_VList_Index		1
#define	HiMIPv6_VList_HomeAddress		2
#define	HiMIPv6_VList_DstAddress		3
#define	HiMIPv6_VList_COA		4
#define	HiMIPv6_VList_ExpireTimer		5
#define	HiMIPv6_VList_State		6


typedef struct t_StatisticsTable
{		
	u_int16_t		RA_rcvd;
	u_int16_t		BU_rcvd;
	u_int16_t		BA_rcvd;
	u_int16_t		BR_rcvd;
	u_int16_t		BU_sent;
	u_int16_t		BA_sent;
	u_int16_t		BR_sent;
	u_int16_t		HiRA_rcvd;
	u_int16_t		HiBU_rcvd;
	u_int16_t		HiBA_rcvd;
	u_int16_t		HiBU_sent;
	u_int16_t		HiBA_sent;
	u_int16_t		HiBI_rcvd;
	u_int16_t		HiBI_sent;
	u_int16_t		HiBU_passed;
	u_int16_t		HiBA_passed;
	u_int16_t		HiBU_blocked;
	
	struct t_StatisticsTable *next;
	
}Mib_StatisticsTable;


typedef struct t_VisitorListTable
{
	u_int32_t		VisitorListIndex;
	
	char 		HomeAddress[38];
	char 		DestinationAddress[38];
	char 		CareOfAddress[38];
	
	u_int16_t 	ExpireTimer ;
	u_int16_t 	State;	
	
	struct t_VisitorListTable *next;
	
}Mib_VisitorListTable;


#endif                          /* _MIBGROUP_EXAMPLE_H */
